var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import * as React from "react";
import LoadingButton from "@mui/lab/LoadingButton";
import Stack from "@mui/material/Stack";
import Button from "@mui/material/Button";
import Alert from "@mui/material/Alert";
import ModalTitle from "./Title";
import DialogContent from "@mui/material/DialogContent";
import { useConnect } from "wagmi";
import StyledModal from "./StyledModal";
import Box from "@mui/material/Box";
import { styled } from "@mui/material/styles";
import Icons from "./Icons";
import useConfigFactory from "../useConfigFactory";
import { availableChains } from "../provider";
import { InjectedConnector } from "wagmi/connectors/injected";
var StyledBox = styled(Box)(function (_a) {
    var theme = _a.theme;
    return ({
        border: "1px",
        borderStyle: "solid",
        borderColor: theme.palette.background.paper,
        borderRadius: theme.shape.borderRadius,
        padding: theme.spacing(1),
        display: "flex",
        flexDirection: "column",
        justifyContent: "space-between",
    });
});
export default function ConnectWalletModal() {
    var config = useConfigFactory()();
    var _a = useConnect(), connect = _a.connect, connectors = _a.connectors, error = _a.error, isLoading = _a.isLoading, pendingConnector = _a.pendingConnector;
    var _b = React.useState(false), open = _b[0], setOpen = _b[1];
    var handleOpen = function () { return setOpen(true); };
    var handleClose = function () { return setOpen(false); };
    React.useEffect(function () {
        connect({
            connector: new InjectedConnector({
                chains: availableChains,
                options: {
                    shimDisconnect: true,
                },
            }),
        });
    }, []);
    return (_jsxs("div", { children: [_jsx(Button, __assign({ onClick: handleOpen, variant: "contained", disableElevation: true }, { children: "Connect Wallet" }), void 0), _jsxs(StyledModal, __assign({ maxWidth: "xs", fullWidth: true, open: open, onClose: handleClose, "aria-labelledby": "alert-dialog-title", "aria-describedby": "alert-dialog-description" }, { children: [_jsx(ModalTitle, { title: "Connect Wallet", handleClose: handleClose, disabled: false }, void 0), _jsx(DialogContent, { children: _jsxs(StyledBox, { children: [error && (_jsx(Alert, __assign({ sx: { my: 2 }, severity: "error" }, { children: error.message }), void 0)), _jsx(Stack, __assign({ spacing: 2, p: 1 }, { children: connectors.map(function (connector) { return (_jsxs(LoadingButton, __assign({ fullWidth: true, variant: "outlined", disableElevation: true, disabled: !connector.ready, startIcon: Icons[connector.id], onClick: function () {
                                            return connect({
                                                connector: connector,
                                                chainId: availableChains.find(function (x) { return x.network === config.chain; }).id,
                                            });
                                        }, loading: isLoading && connector.id === (pendingConnector === null || pendingConnector === void 0 ? void 0 : pendingConnector.id) }, { children: [connector.name, !connector.ready && " (unsupported)"] }), connector.id)); }) }), void 0)] }, void 0) }, void 0)] }), void 0)] }, void 0));
}
